#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include "listes.h"

// ////////////////////////////////////////////////
// Abstract Data Type
// ////////////////////////////////////////////////

// is_empty_list : tests if l is empty
// return:
//    1 if list is empty
//    0 otherwise
bool is_empty_list (List l)
{
	return (l.size == 0) ;
}

// create_empty_list : returns an empty list
// return:
//    empty list structure
List create_empty_list (void)
{
	
	List tmp ;
    tmp.elts = malloc(sizeof(Data*)) ;
	*(tmp.elts) = malloc(sizeof(Data)*ALLOC_BUCK) ;
	tmp.size = 0 ;
	tmp.alloc_size = ALLOC_BUCK ;
	return tmp ;
}

// add : adds element e to the head of the list
// return:
//    resulting list 
List add (Data e, List l)
{
	// Test if there is enough space - otherwise reallocate
	if (l.size == l.alloc_size)
	{
		printf("reallocating size %d . %d\n", l.size, l.alloc_size+ALLOC_BUCK) ;
		Data * tmp ;
		// increase allocated size
		// allocate this new space
		tmp = malloc(sizeof(Data)*(l.alloc_size+ALLOC_BUCK)) ;
		// copy data
		memcpy(tmp, *(l.elts), l.alloc_size*sizeof(Data)) ;
		// free previous data segment and update elts
		free(*(l.elts)) ;
		*(l.elts) = tmp ;
		// adjust alloc_size
		l.alloc_size += ALLOC_BUCK ;
	}
	// Add the new element
	(*(l.elts))[l.size++] = e ;
	return l ;
}

// head : get the head of the list
// return:
//    head
Data head(List l)
{
	assert(!is_empty_list(l)) ;
	return (*(l.elts))[l.size-1] ;
}

// tail : get the tail of the list (fresh copy)
// return:
//    tail
List tail(List l)
{
    List tmp ;
	assert(!is_empty_list(l)) ;
    tmp.elts = malloc(sizeof(Data*)) ;
	*(tmp.elts) = malloc(sizeof(Data)*l.alloc_size) ;
	memcpy(*(tmp.elts), *(l.elts), l.alloc_size*sizeof(Data)) ;
	tmp.size = l.size-1 ; // remove 1 element
    tmp.alloc_size = l.alloc_size ;
	return tmp ;
}

// tail_share : get the tail of the list (in the same "container")
// return:
//    tail
List tail_share(List l)
{
	assert(!is_empty_list(l)) ;
	l.size = l.size-1 ; // remove 1 element
	return l ;
}

// ////////////////////////////////////////////////
// Toolbox
// ////////////////////////////////////////////////

void print_list(List l)
{
	int i ;
	printf("[") ;
	for (i=l.size-1; i>=0; i--)
		printf("%d ", (*(l.elts))[i]) ;
	printf("]\n");
}
